#!/usr/bin/python

#DNA Sequence aligner GUI
#Copyright (C) 2016  Daniel Diaz Molina

#This program is free software; you can redistribute it and/or
#modify it under the terms of the GNU General Public License
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.


import pygtk
pygtk.require('2.0')
import gtk
import string
import alignment
import pango


class mainW: 

    def destroy(self, widget, data=None):
        print "Terminando programa"
        gtk.main_quit()

    def main(self):
        gtk.main()
    
    def read_s_from_file(self, widget, data=None):

        print "Abrir archivo"
        dialog = gtk.FileChooserDialog("Escoga un archivo de texto", None, gtk.FILE_CHOOSER_ACTION_OPEN,
                (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN, gtk.RESPONSE_OK))

        dialog.set_default_response(gtk.RESPONSE_OK)

        filter = gtk.FileFilter()
        filter.set_name("Text files")
        #filter.add_mime_type("text/plain")
        filter.add_pattern("*.txt")
        dialog.add_filter(filter)

        response = dialog.run()
        if response == gtk.RESPONSE_OK:
            print "Archivo leido con exito para secuencia %d" % data
            f1 = open(dialog.get_filename(), 'r')
            texto = f1.read()
            f1.close()
            if data == 1:
                textbuffer = self.s1_view.get_buffer()
                textbuffer.set_text(texto)

            elif data == 2:
                textbuffer = self.s2_view.get_buffer()
                textbuffer.set_text(texto)

            else:
                print "Lectura de texto inesperada"

        else:
            print "No se leyo ningun archivo"
        dialog.destroy()

    def set_algorithm(self, widget):
        print "Set Algo"

    def run_align(self, widget):
        modo = self.method_combo.get_active()

        if modo == -1:
            dialog = gtk.MessageDialog(self.window, gtk.DIALOG_MODAL, gtk.MESSAGE_WARNING,
                    gtk.BUTTONS_OK, "Debe seleccionar un algoritmo de alineamiento.")
            dialog.run()
            dialog.destroy()
        else:
            buf = self.s1_view.get_buffer()
            string1 = buf.get_text(buf.get_start_iter(), buf.get_end_iter())
            string1 = string.strip(string1)
            buf = self.s2_view.get_buffer()
            string2 = buf.get_text(buf.get_start_iter(), buf.get_end_iter())
            string2 = string.strip(string2)

            if len(string1) == 0 or len(string2) == 0:
                dialog = gtk.MessageDialog(self.window, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR,
                        gtk.BUTTONS_OK, "Error, hay secuencias vacias.")
                dialog.run()
                dialog.destroy()

            else:
                print "alineando..."
                if modo == 0 : #Smith-Waterman:
                    s1, r, s2 = alignment.water(string1, string2)
                    texto = "%s\n%s\n%s" % (s1, r, s2)
                    self.r_view.get_buffer().set_text(texto)


                elif modo == 1: #Needleman-Wunsch
                    s1, r, s2 = alignment.needle(string1, string2)
                    texto = "%s\n%s\n%s" % (s1, r, s2)
                    self.r_view.get_buffer().set_text(texto)

            print "Aligned on mode %d" % modo
        print "Run align"

    def __init__(self):

        # Configuracion ventana principal
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.window.set_position(gtk.WIN_POS_CENTER)
        self.window.set_size_request(440,450)
        self.window.set_title("Aligner MARK-I")
        #self.window.set_tooltip_text("This is my GUI")
        
        # Senales ventana principal
        self.window.connect("destroy", self.destroy)

        ####### Componentes del gui

        ### Primera secuencia de ADN (S1)
        # linea 1
        self.s1_box2 = gtk.HBox()
        self.s1_label = gtk.Label("Secuencia 1")
        self.s1_button_file = gtk.Button("Abrir archivo")
        self.s1_button_file.connect("clicked", self.read_s_from_file, 1)
        
        self.s1_box2.pack_start(self.s1_label)
        self.s1_box2.pack_start(self.s1_button_file)

        # linea 2
        self.s1_view = gtk.TextView()
        self.s1_view.set_editable(False)
        self.s1_view.set_cursor_visible(False)
        self.s1_scroll = gtk.ScrolledWindow()
        self.s1_scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.s1_scroll.add(self.s1_view)

        # Layout S1
        self.s1_box1 = gtk.VBox()
        self.s1_box1.pack_start(self.s1_box2, False, False)
        self.s1_box1.pack_start(self.s1_scroll)
        #self.s1_frame = gtk.Frame()
        #self.s1_frame.add(self.s1_box1)


        ### Segunda secuencia de ADN (S1)
        # linea 1
        self.s2_box2 = gtk.HBox()
        self.s2_label = gtk.Label("Secuencia 2")
        self.s2_button_file = gtk.Button("Abrir archivo")
        self.s2_button_file.connect("clicked", self.read_s_from_file, 2)
        
        self.s2_box2.pack_start(self.s2_label)
        self.s2_box2.pack_start(self.s2_button_file)

        # linea 2
        self.s2_view = gtk.TextView()
        self.s2_view.set_editable(False)
        self.s2_view.set_cursor_visible(False)
        self.s2_scroll = gtk.ScrolledWindow()
        self.s2_scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.s2_scroll.add(self.s2_view)

        # Layout S2
        self.s2_box1 = gtk.VBox()
        self.s2_box1.pack_start(self.s2_box2, False, False)
        self.s2_box1.pack_start(self.s2_scroll)
        self.s2_frame = gtk.Frame()
        #self.s2_frame.set_shadow_type(gtk.SHADOW_IN)
        #self.s2_frame.add(self.s2_box1)


        ### Alineamiento (Resultado)

        self.r_label = gtk.Label("Alineamiento de cadenas")

        # Opciones
        self.method_combo = gtk.combo_box_new_text()
        self.method_combo.append_text("[Py] Smith-Waterman")
        self.method_combo.append_text("[Py] Needleman-Wunsch") 
        self.method_combo.connect("changed", self.set_algorithm)

        self.align_button = gtk.Button("Alinear")
        self.align_button.connect("clicked", self.run_align)

        self.opt_box = gtk.HBox(False, 5)
        self.opt_box.pack_start(self.method_combo)
        self.opt_box.pack_end(self.align_button, False, False)

        # Desplegar cadenas alineadas
        self.r_view = gtk.TextView()
        self.r_view.set_editable(False)
        self.r_view.set_cursor_visible(False)
        self.r_scroll = gtk.ScrolledWindow()
        self.r_scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.r_scroll.add(self.r_view)

        # Layout resultado
        self.r_box1 = gtk.VBox()
        self.r_box1.pack_start(self.r_label, False, False, 5)
        self.r_box1.pack_start(self.opt_box, False, False, 5)
        self.r_box1.pack_start(self.r_scroll)
        #self.r_frame = gtk.Frame()


        ########################
        ### Layout Principal ###
        self.vpaned = gtk.VPaned()
        self.vpaned.set_border_width(5)
        self.window.add(self.vpaned)

        # Secuencias de entrada
        self.w_spaned = gtk.VPaned()
        self.w_spaned.pack1(self.s1_box1, True, False)
        self.w_spaned.pack2(self.s2_box1, True, False)
        self.w_sframe = gtk.Frame()
        self.w_sframe.set_size_request(150, 200)
        self.w_sframe.add(self.w_spaned)
        self.w_sframe.set_shadow_type(gtk.SHADOW_ETCHED_OUT)
        self.vpaned.pack1(self.w_sframe, True, False)

        # Resultado
        self.w_rframe = gtk.Frame()
        self.w_rframe.set_size_request(150, 350)
        self.w_rframe.add(self.r_box1)
        self.w_sframe.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        self.vpaned.pack2(self.w_rframe, True, False)

        # Fonts
        fontdesc = pango.FontDescription("monospace 14")
        self.r_view.modify_font(fontdesc)
        self.s1_view.modify_font(fontdesc)
        self.s2_view.modify_font(fontdesc)

        # Mostar la ventana
        self.window.show_all()


if __name__ == "__main__":
    ventana = mainW()
    ventana.main()
                                        

